#!/bin/sh
REF=/pbld/netapp/database/human/b38_decoy/hs38d5.fa #human genome reference
PICARD=/pbld/netapp/apps/picard-tools-2.1.1/picard.jar #picard
JAVA="java -Xmx10g -jar" #java

#DIR_FASTQ=/pbld/mcg/ATAC/patients/fastq/pass_QC # read fastq files directory
#DIR_BAM=/pbld/mcg/lillianpetersen/bam/merged # write bam files
#DIR_BIGWIG=/pbld/mcg/lillianpetersen/bigwig # write bigwig files
#DIR_PEAK=/pbld/mcg/lillianpetersen/peak_allignment/merged # write bigwig files
DIR_FASTQ=/pbld/mcg/lillianpetersen/control/fastq # read fastq files directory
#DIR_BAM=/pbld/mcg/lillianpetersen/bam/control # write bam files
DIR_BAM=/pbld/mcg/lillianpetersen/ABC/data/bam # read bam files
DIR_PEAK=/pbld/mcg/lillianpetersen/peak_allignment # write bigwig files

Allignment=False
CallPeak=True

#for Type in B_cell CLP_cell myeliod_cell T_cell
for Type in B_cell
	do
	
	############## declare sample Names ##############
	if [ $Type = B_cell ]
		then
		declare -a samples=(MCG001 MCG002 MCG003 MCG005 MCG006 MCG009 MCG010 MCG011 MCG012 MCG013 MCG016 MCG017 MCG019 MCG020 MCG023 MCG024 MCG027 MCG028 MCG029 MCG030 MCG034 MCG035 MCG036 MCG037 MCG038 MCG039)
	fi
	if [ $Type = T_cell ]
		then
		declare -a samples=("Put T Cell Samples Here")
	fi
	if [ $Type = myeliod_cell ]
		then
		declare -a samples=("Put T Cell Samples Here")
	fi
	echo $Type
	echo "${samples[@]}"

	############## loop through samples ##############
	for i in "${samples[@]}"
		do
		printf "\n\n\n\n"
		echo $i
		
		if [ $Allignment = True ]
			then
			echo Allignment
			########## Allignment ###########
			bwa mem -t 8 $REF $DIR_FASTQ/$Type/$i\_R1.fastq $DIR_FASTQ/$Type/$i\_R2.fastq |\
			samtools view -bS -o $DIR_BAM/$Type/$i.bam # save as bam
			
			echo sorting
			samtools sort -T $DIR_BAM/$Type/$i -o $DIR_BAM/$Type/$i\.srt.bam $DIR_BAM/$Type/$i.bam # sort
			
			$JAVA $PICARD MarkDuplicates INPUT=$DIR_BAM/$Type/$i\.srt.bam OUTPUT=$DIR_BAM/$Type/$i.srt.nodup.bam METRICS_FILE=$DIR_BAM/$Type/metrics.$i.txt ASSUME_SORTED=true REMOVE_DUPLICATES=true #remove duplicates
			samtools view -h $DIR_BAM/$Type/$i.srt.nodup.bam | perl -ne '{chomp; if ($_ =~ m/^\@/) {print $_ . "\n";} else {split; if ($_[2] !~ m/chrM/ && $_[2] !~ m/^chrUn/ && $_[4] >= 30) {print $_ . "\n";}}}' | samtools view -bS -o $DIR_BAM/$Type/$i\_nodup_nochrM.srt.bam
		
			echo indexing
			#samtools index $DIR_BAM/$i\_nodup_nochrM.srt.bam
			samtools index $DIR_BAM/$Type/$i\_nodup_nochrM.srt.bam
			
			rm $DIR_BAM/$Type/$i.bam
			rm $DIR_BAM/$Type/$i\_srt.bam
			rm $DIR_BAM/$Type/$i.srt.nodup.bam
			##################################
		fi
		
		if [ $CallPeak = True ]
			then
			echo CallPeak
			printf "\n"
			macs2 callpeak -t $DIR_BAM/$i\d_rmMT_rmDup_rmLQ_paired.bam -f BAM -g hs -n $DIR_PEAK/$Type/$i -B -q 0.01
			
			bedtools intersect -v -a $DIR_PEAK/$Type/$i\_peaks.narrowPeak -b /pbld/netapp/home/zxu/reference/hg38/hg38.blacklist.bed > $DIR_PEAK/$Type/$i\_filtered.narrowPeak   # removed unmapped sections of the genome
			
			bedtools multicov -bams $DIR_BAM/$i\d_rmMT_rmDup_rmLQ_paired.bam -bed $DIR_PEAK/$Type/$i\_filtered.narrowPeak > $DIR_PEAK/$Type/$i\_counts.txt
		fi
		#
		## histogram/bedgraph summary of feature coverage
		#genomeCoverageBed -bg -ibam $DIR_BAM/$i\_nodup_nochrM.bam -g $REF.fai | grep -v chrUn | grep -v random | grep -v EBV  > $DIR_BIGWIG/$i\_nodup_nochrM.bdg
		#
		## bigWig format: dense, continuous data to be displayed in the Genome Browser as a graph
		#wigToBigWig $DIR_BIGWIG/$i\_nodup_nochrM.bdg /pbld/netapp/apps/ucsc/hg38_decoy.chrom.sizes $DIR_BIGWIG/$i\_nodup_nochrM.bw
		
	done
done
