#!/bin/sh
REF=/pbld/netapp/database/human/b38_decoy/hs38d5.fa #human genome reference
PICARD=/pbld/netapp/apps/picard-tools-2.1.1/picard.jar #picard
JAVA="java -Xmx10g -jar" #java

DIR=/pbld/mcg/lillianpetersen # home
DIR_FASTQ=/pbld/mcg/ATAC/patients/fastq/pass_QC # read fastq files directory
DIR_BAM=/pbld/mcg/lillianpetersen/ABC/data/bam/ # read bam files
DIR_BIGWIG=/pbld/mcg/lillianpetersen/bigwig # write bigwig files
DIR_PEAK=/pbld/mcg/lillianpetersen/peak_allignment # write bigwig files

MCG=True
BALL=False
TALL=False
AML=False
All=False

####################### MCG #######################

if [ $MCG = True ]
then
printf '\nMCG' $MCG
#for i in MCG001 MCG002 MCG003 MCG005 MCG006 MCG009 MCG010 MCG011 MCG012 MCG013 MCG016 MCG017 MCG019 MCG020 MCG023 MCG024 MCG027 MCG028 MCG034 MCG035 MCG036 MCG037 MCG038 MCG039
for i in MCG017
do

printf '\n'
echo $i
bedtools multicov -bams $DIR_BAM/$i\d_rmMT_rmDup_rmLQ_paired.bam -bed $DIR_PEAK/B_ALL_bedtools.output.txt > $DIR_PEAK/B_cell/$i\_merged_counts.txt

#total=$(awk '{SUM += $4} END {print SUM}' $DIR_PEAK/$i\_merged_counts.txt | awk '{print $1/1000000}') # sum reads in peaks
total=$(awk '{SUM += $4} END {print SUM}' $DIR_PEAK/B_cell/$i\_merged_counts.txt | awk '{print $1/1000000}') # sum reads in peaks
#num=$total/1000000
echo $total

grep -v chrUn $DIR_PEAK/B_cell/$i\_merged_counts.txt | grep -v random | grep -v EBV | awk '{print $1"\t"$2"\t"$3"\t"$4/'"$total"'}' > $DIR_PEAK/B_cell/$i\_rpm_merged_counts.txt  # normalize counts

done
fi

####################### All #######################

if [ $ALL = True ]
then
echo ALL
declare -a Type=("B_ALL" "T_ALL" "AML" "B_ALL" "B_ALL" "B_ALL" "AML" "B_ALL" "B_ALL" "B_ALL" "B_ALL" "B_ALL" "B_ALL"  "B_ALL" "T_ALL" "B_ALL" "B_ALL" "B_ALL" "B_ALL" "B_ALL"  "B_ALL" "T_ALL" "T_ALL")
declare -a sample=('BALL_control' 'TALL_control' 'AML_control' 'MCG001' 'MCG002' 'MCG003' 'MCG004' 'MCG005' 'MCG006' 'MCG009' 'MCG010' 'MCG011' 'MCG012' 'MCG013' 'MCG015' 'MCG016' 'MCG017' 'MCG019' 'MCG020' 'MCG023' 'MCG024' 'MCG025' 'MCG026')
arraylength=${#sample[@]}
for (( i=1; i<${arraylength}+1; i++ )); 
do

	bedtools multicov -bams $DIR_BAM/${sample[$i-1]}\_nodup_nochrM.srt.bam -bed $DIR_CONTROL/All/All_bedtools.output.txt > $DIR_CONTROL/All/${sample[$i-1]}\_merged_counts.txt
	
	total=$(awk '{SUM += $4} END {print SUM}' $DIR_CONTROL/All/${sample[$i-1]}\_merged_counts.txt | awk '{print $1/1000000}') # sum reads in peaks
	#num=$total/1000000
	echo $total
	
	grep -v chrUn $DIR_CONTROL/All/${sample[$i-1]}\_merged_counts.txt | grep -v random | grep -v EBV | awk '{print $1"\t"$2"\t"$3"\t"$4/'"$total"'}' > $DIR_CONTROL/All/${sample[$i-1]}\_rpm_merged_counts.txt  # normalize counts

done
fi

####################### B ALL #######################

if [ $BALL = True ]
then
echo B ALL
declare -a Dir=("control/CLP_cell" "control/CLP_cell" "control/CLP_cell" "control/CLP_cell" "control/CLP_cell" "control/B_cell" "control/B_cell" "control/B_cell" "control/B_cell" "merged" "merged" "merged" "merged" "merged" "merged" "merged" "merged" "merged" "merged" "merged" "merged" "merged" "merged" "merged" "merged")
declare -a sample=('SRX821' 'SRX822' 'SRX845' 'SRX851' 'SRX868' 'SRX815' 'SRX836' 'SRX840' 'SRX867' 'MCG001' 'MCG002' 'MCG003' 'MCG005' 'MCG006' 'MCG009' 'MCG010' 'MCG011' 'MCG012' 'MCG013' 'MCG016' 'MCG017' 'MCG019' 'MCG020' 'MCG023' 'MCG024')

for (( i=1; i<${arraylength}+1; i++ )); 

do

	bedtools multicov -bams $DIR_BAM/$i\_nodup_nochrM.srt.bam -bed $DIR_CONTROL/B_ALL/B_ALL_bedtools.output.txt > $DIR_CONTROL/B_ALL/$i\_merged_counts.txt
	bedtools multicov -bams $DIR_BAM/${Dir[$i-1]}/${sample[$i-1]}\_nodup_nochrM.srt.bam -bed $DIR_CONTROL/All/All_bedtools.output.txt > $DIR_CONTROL/All/${sample[$i-1]}\_merged_counts.txt

total=$(awk '{SUM += $4} END {print SUM}' $DIR_CONTROL/B_ALL/$i\_merged_counts.txt | awk '{print $1/1000000}') # sum reads in peaks
#num=$total/1000000
echo $total

grep -v chrUn $DIR_CONTROL/B_ALL/$i\_merged_counts.txt | grep -v random | grep -v EBV | awk '{print $1"\t"$2"\t"$3"\t"$4/'"$total"'}' > $DIR_CONTROL/B_ALL/$i\_rpm_merged_counts.txt  # normalize counts

done
fi

####################### T ALL #######################

if [ $TALL = True ]
then
echo T ALL
for i in TALL_control MCG015 MCG025 MCG026

do

bedtools multicov -bams $DIR_BAM/$i\_nodup_nochrM.srt.bam -bed $DIR_CONTROL/T_ALL/T_ALL_bedtools.output.txt > $DIR_CONTROL/T_ALL/$i\_merged_counts.txt

total=$(awk '{SUM += $4} END {print SUM}' $DIR_CONTROL/T_ALL/$i\_merged_counts.txt | awk '{print $1/1000000}') # sum reads in peaks
#num=$total/1000000
echo $total

grep -v chrUn $DIR_CONTROL/T_ALL/$i\_merged_counts.txt | grep -v random | grep -v EBV | awk '{print $1"\t"$2"\t"$3"\t"$4/'"$total"'}' > $DIR_CONTROL/T_ALL/$i\_rpm_merged_counts.txt  # normalize counts

done
fi

####################### AML #######################

if [ $AML = True ]
then
echo AML
for i in AML_control MCG004

do

bedtools multicov -bams $DIR_BAM/$i\_nodup_nochrM.srt.bam -bed $DIR_CONTROL/AML/AML_bedtools.output.txt > $DIR_CONTROL/AML/$i\_merged_counts.txt

total=$(awk '{SUM += $4} END {print SUM}' $DIR_CONTROL/AML/$i\_merged_counts.txt | awk '{print $1/1000000}') # sum reads in peaks
#num=$total/1000000
echo $total

grep -v chrUn $DIR_CONTROL/AML/$i\_merged_counts.txt | grep -v random | grep -v EBV | awk '{print $1"\t"$2"\t"$3"\t"$4/'"$total"'}' > $DIR_CONTROL/AML/$i\_rpm_merged_counts.txt  # normalize counts

done
fi
