import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
from sys import exit

wd = '/pbld/mcg/lillianpetersen/' # working typeectory

MCG = False
All = False
BALL = True
TALL = False
AML = False

########################## MCG ##########################
if MCG:
	print 'MCG'
	sampleNames = np.array(['MCG001', 'MCG002', 'MCG003', 'MCG004', 'MCG005', 'MCG006', 'MCG007', 'MCG009', 'MCG010', 'MCG011', 'MCG012', 'MCG013', 'MCG015', 'MCG016', 'MCG017', 'MCG019', 'MCG020', 'MCG023', 'MCG024', 'MCG025','MCG026'])
	
	i = -1
	for sample in sampleNames:
		i+=1
		array = pd.read_csv(wd+'peak_allignment/merged/'+sample+'_rpm_merged_counts.txt',sep='\t',header=None,names=['chr','posStart','posStop','rpm']) # read rpm merged peak counts
		length = (array['posStop']-array['posStart'])/1000 # length in kilobases
	
		rpkm = array['rpm']/length # divide rpkm by length
		rpkm = pd.DataFrame(data = rpkm, columns = ['rpkm'])
	
		array_rpkm = pd.concat([array['chr'], array['posStart'], array['posStop'], rpkm], axis = 1)
	
		# write to csv
		array_rpkm.to_csv(wd+'peak_allignment/merged/'+sample+'_rpkm_merged_counts.txt',sep='\t', header=False, index=False)
	exit()

########################## All ##########################
if All:
	sampleNames = np.array(['BALL_control', 'TALL_control', 'AML_control', 'MCG001', 'MCG002', 'MCG003', 'MCG004', 'MCG005', 'MCG006', 'MCG007', 'MCG009', 'MCG010', 'MCG011', 'MCG012', 'MCG013', 'MCG015', 'MCG016', 'MCG017', 'MCG019', 'MCG020', 'MCG023', 'MCG024', 'MCG025', 'MCG026'])
	Type = 'All'
	print Type

	i = -1
	for sample in sampleNames:
		i+=1
		array = pd.read_csv(wd+'peak_allignment/with_control/'+Type+'/'+sample+'_rpm_merged_counts.txt',sep='\t',header=None,names=['chr','posStart','posStop','rpm']) # read rpm merged peak counts
		length = (array['posStop']-array['posStart'])/1000 # length in kilobases
	
		rpkm = array['rpm']/length # divide rpkm by length
		rpkm = pd.DataFrame(data = rpkm, columns = ['rpkm'])
	
		array_rpkm = pd.concat([array['chr'], array['posStart'], array['posStop'], rpkm], axis = 1)
	
		# write to csv
		array_rpkm.to_csv(wd+'peak_allignment/with_control/'+Type+'/'+sample+'_rpkm_merged_counts.txt',sep='\t', header=False, index=False)

########################## B ALL ##########################
if BALL:
	#sampleNames = np.array(['MCG001', 'MCG002', 'MCG003', 'MCG005', 'MCG006', 'MCG009', 'MCG010', 'MCG011', 'MCG012', 'MCG013', 'MCG016', 'MCG017', 'MCG019', 'MCG020', 'MCG023', 'MCG024', 'MCG027', 'MCG028', 'MCG029', 'MCG034', 'MCG035', 'MCG036', 'MCG037', 'MCG038', 'MCG039'])
	sampleNames = np.array(['MCG017'])
	Type = 'B_ALL'
	print Type

	i = -1
	for sample in sampleNames:
		i+=1
		array = pd.read_csv(wd+'peak_allignment/B_cell/'+sample+'_rpm_merged_counts.txt',sep='\t',header=None,names=['chr','posStart','posStop','rpm']) # read rpm merged peak counts
		length = (array['posStop']-array['posStart'])/1000 # length in kilobases
	
		rpkm = array['rpm']/length # divide rpkm by length
		rpkm = pd.DataFrame(data = rpkm, columns = ['rpkm'])
	
		array_rpkm = pd.concat([array['chr'], array['posStart'], array['posStop'], rpkm], axis = 1)
	
		# write to csv
		array_rpkm.to_csv(wd+'peak_allignment/B_cell/'+sample+'_rpkm_merged_counts.txt',sep='\t', header=False, index=False)

########################## T ALL ##########################
if TALL:
	sampleNames = np.array(['TALL_control','MCG015', 'MCG025', 'MCG026'])
	Type = 'T_ALL'
	print Type

	i = -1
	for sample in sampleNames:
		i+=1
		array = pd.read_csv(wd+'peak_allignment/with_control/'+Type+'/'+sample+'_rpm_merged_counts.txt',sep='\t',header=None,names=['chr','posStart','posStop','rpm']) # read rpm merged peak counts
		length = (array['posStop']-array['posStart'])/1000 # length in kilobases
	
		rpkm = array['rpm']/length # divide rpkm by length
		rpkm = pd.DataFrame(data = rpkm, columns = ['rpkm'])
	
		array_rpkm = pd.concat([array['chr'], array['posStart'], array['posStop'], rpkm], axis = 1)
	
		# write to csv
		array_rpkm.to_csv(wd+'peak_allignment/with_control/'+Type+'/'+sample+'_rpkm_merged_counts.txt',sep='\t', header=False, index=False)

########################## AML ##########################
if AML:
	sampleNames = np.array(['AML_control','MCG004'])
	Type = 'AML'
	print Type

	i = -1
	for sample in sampleNames:
		i+=1
		array = pd.read_csv(wd+'peak_allignment/with_control/'+Type+'/'+sample+'_rpm_merged_counts.txt',sep='\t',header=None,names=['chr','posStart','posStop','rpm']) # read rpm merged peak counts
		length = (array['posStop']-array['posStart'])/1000 # length in kilobases
	
		rpkm = array['rpm']/length # divide rpkm by length
		rpkm = pd.DataFrame(data = rpkm, columns = ['rpkm'])
	
		array_rpkm = pd.concat([array['chr'], array['posStart'], array['posStop'], rpkm], axis = 1)
	
		# write to csv
		array_rpkm.to_csv(wd+'peak_allignment/with_control/'+Type+'/'+sample+'_rpkm_merged_counts.txt',sep='\t', header=False, index=False)
